cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  SVM-QP, written by Katya Scheinberg, IBM Research, 2005.
c  to contact the author email at katyas'at'us'dot'ibm'dot'com
c
c Copyright (C) 2005 International Business Machines.
c All Rights Reserved.
c This code is published under the Common Public License.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine actvset(points,  ipoints, lpnt, ipntr, a, c, x, y,  is, 
     .                   ic, i0, ns,  nc, n0, n, k,
     .                   ibeg, nrnk, maxit, xs, qxs, qus, qxc,  
     .                   quc,qx0, qu0, iqs, qs, qc,
     .                   thresh, i0ind, icind, icdisc,  
     .                   ncdisc, i0disc, n0disc, shftk, dgrk, maxns,
     .                   maxn, g, perm, fullmem, usesift, minslk, 
     .                   iminslk, maxsift0, minsur,iminsur, maxsiftc,
     .                   initlz, tol, iter,itertotal, iprint, wrk, lwrk, 
     .                   iwrk,liwrk)
      double precision  a(maxn), c, x(maxn), y, points(lpnt), xs(n),
     .                  qxs(n), qus(n), qxc(n), quc(n), qx0(n), qu0(n),
     .                  qs(maxn, maxns), g(maxns, maxns), qc(maxn), 
     .                   wrk(lwrk), shift, shftk, tol, tmp
      integer           is(n), ic(n), i0(n), i0ind(n), icind(n),
     .                  iqs(n), i0disc(n0disc), n0disc, perm(maxns), 
     .                  icdisc(n), ncdisc, ns, nc,  ibeg, thresh,
     .                  n0, n, k, maxit, nrnk, liwrk, lwrk, iwrk(liwrk), 
     .                  dgrk, maxn, ipoints(lpnt), ipntr(maxn), lpnt,
     .                  iprint, maxsift0, maxsiftc
      double precision  min0, minc, minsc, mins0, ac, inf, dir,
     .                  ax, ay, fval, dy, totalt, anorm, rcond, u,
     .                  ynew, schur, rhs, erro, val, minslk(maxsift0),
     .                  minsur(maxsiftc), val2, maxval
      integer           imin0, iminc, imins0, iminsc, i, j, j1, l,icurw,  
     .                  icuriw,  iter, itertotal, maxns,
     .                  iperm, istep,  lqsc, iqsc,  iq,
     .                  nsold, ldg, iterbig, fullmem, jj, 
     .                  ii, iterc, laststep, ienter, iminslk(maxsift0),
     .                  iminsur(maxsiftc)
      logical           brkpt, incactset, usesift, lowrnk,
     .                  initlz
      double precision gkernlsp
      external         gkernlsp
      intrinsic        min, max
c
c  This subroutine solves a static SVM problem (with a given number of points) via an
c  active set method. Initial point is given via the partition of indices into sets
c  Is, I0 and Ic corrsponding set of indices of the variable that are between the upper
c  lower bound, at lower bound 0 and at upper bound c. The values of the variable that
c  are not on their bound are also given in 'xs'.
c  The essential structure of the algorithm is the following: at each iterations there
c  is a partition of I={1,...,n}: Is, Ic, I0. Each Ic and I0 is subdivided into Ic and Icdisc
c  and I0 and I0disc respectively. I0disc and Icdisc contain the indices of variable that
c  are temporarily ignored and assumed to be at their upper or lower bound. There are two  
c  strategies by which  indices enter Icdisc or I0disc . One is "shrinking", where we ingnore
c  a variable that has been at its bound for more than 100 iteration in a row (100 maybe 
c  changed to another threshold). The second strategy is "sifting" - where we only consider a 
c  fixed number of variables at at time, those who correspond to the most "active" contraints.
c  Once a problem with the smaller number of constraints is solved, the other constraints
c  are considered again. 
c
c  On each iterations the first the reduced problem is 
c  solved with respect to variables in Is only. Then the costraints that correspoind to
c  I0 and Ic are checked. The most violated constraint is included in the "active" set
c  and the corresponded variable is released from its bound (and corresponding index is
c  removed from I0 or Ic and added to Is). Only if all constraints of I0 and Ic are 
c  satisfied the algorithm looks at the constraints of I0disc and Icdisc.
c
c  There are following data structures: 
c  1. 'qs' is the matrix of columns of Q that correspond 
c  to the indices set Is. The rows in qs depend on the level of memory consumption.
c  full_memory=2 means that complete column of Q are in qs. If full_memory=1 then
c  only rows with indices in Is, I0 and Ic (but not in Icdisc and I0disc) are in
c  qs.
c
c  ATTENTION: full_mememory=1 only mimics a limited use of memory in a dynamic
c  memory allocation environment. Since right now the memory is allocated in a static way
c  and due to some simplified implementation the actual use of memory is the same for
c  both cases.
c
c  The columns in 'qs' are removed and added, along the way of the algorithm.
c  Array iqs is the array of pointers that indicates for each variable in Is
c  which column in qs this variable corresponds to.
c
c  2. 'qc' is the vector which is c*Qc*e, where Qc is the columns of Q that correspond to
c  the current Ic and Icdisc, e is the unit vector of appropriate dimension.
c  
c  3. 'g' is the Cholesky factor of Qss at each iteration
c
c  4. 'perm' - the array of permuations of the rows and columns of Qss that produce the
c     current Cholesky factor G.
c


      totalt=0.0d0
c
c  memory pointers
c
      icurw=1
      icuriw=1
c
c  initial value for the right hand side c*a\t*e_c of the reduced QP
c
      ac=0.0d0
      do 5 i=1, nc
        ac=ac+a(ic(i))
 5    continue  
      do 6 i=1, ncdisc
        ac=ac+a(icdisc(i))
 6    continue  
      inf = 1.0d20
c  number of iterations where a variable is realeased from the upper bound
      iterc=0
c  initiating some auxilliary variables
      incactset=.true.
      ienter=0
      laststep=0
c
c  if using sifting and the sets Icdisc and I0disc has not been chosen yet, 
c  put all currently inactive constraints there. At the next iteration
c  when a next active constraint is chosen (a variable is released from its
c  bound) the set Icdisc and I0disc will be recomputed.
c
      if ( usesift .and. .not. initlz) then 
        do 7 i=1, n0 
          n0disc=n0disc+1
          i0disc(n0disc)=i0(i)
7       continue
        n0=0
        do 8 i=1, nc
          ncdisc=ncdisc+1
          icdisc(ncdisc)=ic(i)
 8      continue
        nc=0
      endif
c  main iteration
c
      iterbig=0
      do 500 iter=1, maxit
        if ( .not. usesift ) then 
c
c  If using "shrinking" discard the non-active points: check if any more of the variables have been at the upper
c  or lower bounds for more than 'thresh' iteration in a row.
c
          if ( iter+itertotal .gt. thresh ) then
            call discpts(i0, n0, i0ind, i0disc, 
     *                   n0disc, x, 0.0d0, maxn, thresh)
            call discpts(ic, nc, icind, icdisc, 
     *                   ncdisc, x, c, maxn, thresh)
          endif
        endif
c
c  check if the number of points in Is is greater than maximum allowed by the
c  program (due to memory allocation)
c
        if ( ns .gt. maxns ) then
          if (iprint.ge.0) write(6,*) 
     .    'ERROR: too many active points. The optimization will stop'
          goto 2000
        endif 
c
c  printout of iterations
c

        i=(iter/10)*10-iter 
        if ( (iprint .ge. 2 .and. i  .le. 0) .or. 
     .      (iprint .ge. 1 .and. i  .eq. 0) ) then
             write(6,*) 'iter=', iter, 
     .      'y=', y,  'ns=', ns, 'nc=', nc, 'n0=', n0, 'ncdisc=', 
     .      ncdisc, 'n0disc=', n0disc
        endif
c
c  If the set of active constraints is empty go to the step which chooses the 
c  next active constraint
c
        if ( ns .eq. 0 ) goto 600
c
c  compute the qus=-Qcs*c+e, qxs=a_s 
c
        do 10 i=1, ns
          qus(i)=-qc(is(i))+1.0d0
          qxs(i)=a(is(i))
 10     continue

c
c Factorize Qss=LsLs^{T}. Factorization is done, when required, and starts from index 'ibeg'.
c This way is we need to recompute only the last  few columns of the Cholesky factor we
c do not need to start from scratch.
c
        if ( incactset ) then
          ldg = maxns 
          call cholpiv(qs, iqs, is, g, ldg, perm,  
     .       ibeg, ns, nrnk, maxn, maxns, 1.0d-12)
          incactset=.false.
          brkpt=.false.
        endif

c
c  If Qss nonsingular then find qus:= Ls^{-1}qus and qxs:=Ls^{-1}qxs
c
        if ( nrnk .eq. ns ) then
          call  frwslvpiv(g, ldg, qxs, perm, ns, nrnk)
          call  frwslvpiv(g, ldg, qus, perm, ns, nrnk)
c
c  Compute the solution to the equality constrained QP
c
          rhs=0.0d0
          schur=0.0d0
          do 50 i=1, ns
            rhs=-qxs(i)*qus(i)+rhs
            schur=schur+qxs(i)*qxs(i)
 50       continue
          rhs=rhs-ac*c
c
c  qxs and ynew is the optimal solution to the equlity constraint QP.
c  They will define the Newton step.
c 
          ynew=rhs/schur
          do 60 i=1,ns
            qxs(i)=ynew*qxs(i)+qus(i)
 60       continue  
c
c  qxs:=Ls^{-T}qxs
c
          call  bkwslvpiv(g, ldg, qxs, perm, ns, nrnk)
c
c  If singular but the rank is only 1 smaller than the size of the
c  matrix Qss there is still hope to solve the equality constrained
c  QP
c
        else if (nrnk .eq. ns - 1) then 
          call  frwslvpiv(g, ldg, qxs, perm, ns, nrnk)
          call  frwslvpiv(g, ldg, qus, perm, ns, nrnk)
          i=perm(ns)
          do 110 j=1,ns
            qxc(j)=qs(is(j), iqs(i))
 110      continue
          call  frwslvpiv(g, ldg, qxc, perm, ns, nrnk) 
          rhs=1.0d0-qc(is(i))
          val=a(is(i))
          maxval=abs(val)
          do 120 j=1,ns-1
            jj=perm(j)
            rhs=rhs-qxc(jj)*qus(jj)
            val=val-qxc(jj)*qxs(jj)
            if (abs(val) .gt. maxval) maxval=abs(val)
 120      continue
c
c  If the coefficient of y in the equation is zero, then the problem is unbounded
c  and we determine an infinite descent direction
c
          if ( abs(val) .lt. 1.0d-8*(maxval+1.0d0) ) then
             call  bkwslvpiv(g, ldg, qxc, perm, ns, nrnk) 
             if ( rhs .lt. -1.0d-8 ) then
               dir = 1.0d0
             else
               dir = -1.0d0
             endif
             do 125 j=1,ns-1
               jj=perm(j)
               qxs(jj)=qxc(jj)
 125         continue   
             qxs(perm(ns))=-1.0d0
             brkpt=.true.
          else 
c
c  If the coefficient of y is not zero, then there is a finite solution
c
            ynew=-rhs/val
            do 130 j=1,ns-1
              jj=perm(j)
              qus(jj)=qus(jj)+ynew*qxs(jj)
 130        continue
            rhs=ac*c
            val=-a(is(i))
            do 140 j=1,nrnk
              jj=perm(j)
              rhs=rhs+qxs(jj)*qus(jj)
              val=val+qxs(jj)*qxc(jj)
 140        continue

c
c  solve for xs(ns). If coefficient with xs(ns) is 0 then something is wrong
c
c            if (abs(val) .lt. 1.0d-8*(1+1.0d-2*abs(qs(is(i), iqs(i)))))
c     .          then
c             stop
c            endif
            qxs(i)=rhs/val
            do 150 j=1,nrnk
              jj=perm(j)
              qxs(jj)=qus(jj)-qxc(jj)*qxs(i)
 150        continue
            call  bkwslvpiv(g, ldg, qxs, perm, ns, nrnk)  
          endif      
        else if ( nrnk .lt.ns-2 ) then
c
c  if Qss is singular with 2  zero eigenvalues, then find an infinite direction
c
          call  frwslvpiv(g, ldg, qxs, perm, ns, nrnk)
          call  bkwslvpiv(g, ldg, qxs, perm, ns, nrnk)
          i=perm(nrnk+2)
          ii=perm(nrnk+1)
          do 151 j=1,ns
            qxc(j)=qs(is(j), iqs(i))
            qus(j)=qs(is(j), iqs(ii))
 151      continue 
          val=a(is(i))
          val2=a(is(ii))
          maxval=abs(val)
          do 152 j=1,nrnk
            jj=perm(j)
            val=val-qxc(jj)*qxs(jj)
            if (abs(val) .gt. maxval) maxval=abs(val)
            val2=val2-qus(jj)*qxs(jj)
 152      continue
c
c  If val=0 then we compute one descent direction and if val is not 0 then another descent direction
c
c
          if ( abs(val) .lt. 1.0d-8*(maxval+1.0d0) ) then
            call  frwslvpiv(g, ldg, qxc, perm, ns, nrnk)
            call  bkwslvpiv(g, ldg, qxc, perm, ns, nrnk)   
            do 153 j=1,nrnk
              jj=perm(j)
              qxs(jj)=qxc(jj)
 153        continue   
            qxs(perm(nrnk+2))=-1.0d0 
            qxs(perm(nrnk+1))=0.0d0
            do 154 i=nrnk+3,ns 
              qxs(perm(j))=0.0d0
 154        continue  
            dir=0.0d0
            do 155 j=1,ns
              jj=perm(j)
              dir=dir+(-qc(is(jj))+1.0d0)*qxs(jj)
 155        continue
            if ( dir .lt. -1.0d-8) then
              dir = -1.0d0
            else
              dir=1.0d0 
            endif
            brkpt=.true.
          else 
            val=val2/val
            do 156 j=1,nrnk
              jj=perm(j)
              qxs(jj)=qus(jj)-val*qxc(jj)
 156        continue
            call  frwslvpiv(g, ldg, qxs, perm, ns, nrnk)
            call  bkwslvpiv(g, ldg, qxs, perm, ns, nrnk)  
            qxs(perm(nrnk+1))=-1.0d0 
            qxs(perm(nrnk+2))=val 
            do 157 i=nrnk+3,ns 
              qxs(perm(j))=0.0d0
 157        continue  
            dir=0.0d0
            do 158 j=1,ns
              jj=perm(j)
              dir=dir+(-qc(is(jj))+1.0d0)*qxs(jj)
 158        continue
            if ( dir .lt. -1.0d-8) then
              dir = -1.0d0
            else
              dir=1.0d0 
            endif
            brkpt=.true.
          endif
        else
c
c  if Qss is singular with 2  zero eigenvalues, then find an infinite direction
c
          i=perm(ns)
          ii=perm(ns-1)
          qxs(i)=0.0d0
          qxs(ii)=0.0d0          
          call  frwslvpiv(g, ldg, qxs, perm, nrnk, nrnk)
c          call  bkwslvpiv(g, ldg, qxs, perm, nrnk, nrnk)
          do 160 j=1,nrnk
            qxc(perm(j))=g(ns, j)
            qus(perm(j))=g(ns-1, j)
 160      continue
          qxc(i)=0.0d0
          qxc(ii)=0.0d0
          qus(i)=0.0d0
          qus(ii)=0.0d0
c          call  frwslvpiv(g, ldg, qxc, perm, nrnk, nrnk)
c          call  frwslvpiv(g, ldg, qus, perm, nrnk, nrnk)
          val=a(is(i))
          val2=a(is(ii))
          maxval=abs(val)
          do 170 j=1,nrnk
            jj=perm(j)
            val=val-qxc(jj)*qxs(jj)
            if (abs(val).gt.maxval) maxval=abs(val)
            val2=val2-qus(jj)*qxs(jj)
 170      continue
c
c  If val=0 then we compute one descent direction and if val is not 0 then another descent direction
c
c
          if ( abs(val) .lt. 1.0d-8*(maxval+1.0d0) ) then
c             call  frwslvpiv(g, ldg, qxc, perm, nrnk, nrnk)
             call  bkwslvpiv(g, ldg, qxc, perm, nrnk, nrnk)   
             do 175 j=1,ns-2
               jj=perm(j)
               qxs(jj)=qxc(jj)
 175         continue   
             qxs(perm(ns))=-1.0d0 
             qxs(perm(ns-1))=0.0d0
             dir=0.0d0
             do 178 j=1,ns
               jj=perm(j)
               dir=dir+(-qc(is(jj))+1.0d0)*qxs(jj)
 178         continue
             if ( dir .lt. -1.0d-8) then
                dir = -1.0d0
             else
               dir=1.0d0 
             endif
             brkpt=.true.
          else 
            val=val2/val
            do 180 j=1,nrnk
              jj=perm(j)
              qxs(jj)=qus(jj)-val*qxc(jj)
 180        continue
c           call  frwslvpiv(g, ldg, qxs, perm, nrnk, nrnk)
            call  bkwslvpiv(g, ldg, qxs, perm, nrnk, nrnk)  
            qxs(perm(ns-1))=-1.0d0 
            qxs(perm(ns))=val  
            dir=0.0d0
            do 185 j=1,ns
              jj=perm(j)
              dir=dir+(-qc(is(jj))+1.0d0)*qxs(jj)
 185        continue
            if ( dir .lt. -1.0d-8) then
              dir = -1.0d0
            else
              dir=1.0d0 
            endif
c            if (laststep .eq. 1 .or. laststep .eq. 3 ) then
c              if ( qxs(ns).gt. 0 ) then 
c                dir=1.0d0
c              else
c                dir=-1.0d0 
c              endif 
c            else if (laststep .eq. 2 .or. laststep .eq. 4 ) then
c              if ( qxs(ns).lt. 0 ) then 
c                dir=1.0d0
c              else
c                dir=-1.0d0 
c              endif 
c            endif     
            brkpt=.true.
          endif
        endif

c
c  finding the min ratio to determine the step along the Newton direction until the boundary is hit.
c  also determine which variable hits the bound and therefore switches from Is to I0 or Ic.
c              
          if ( .not. brkpt ) then 
            mins0=inf
            imins0=0
            do 190 i=1, ns
              if ( qxs(i)-xs(i) .lt. -1.0d-10 .and. 
     .             xs(i)/(xs(i)-qxs(i))<mins0 ) then
                mins0  = xs(i)/(xs(i)-qxs(i))
                imins0=i
              endif
 190        continue      
            minsc=inf
            iminsc=0
            do 200 i=1, ns
              if ( qxs(i)-xs(i)  .gt. 1.0d-10 .and.  
     .             (c-xs(i))/(qxs(i)-xs(i)) < minsc ) then
                 minsc  =(c-xs(i))/(qxs(i)-xs(i))
                 iminsc=i
              endif
 200        continue 
            dy=min(1.0d0, min(minsc, mins0))
            do 205 i=1,ns
              xs(i)=xs(i)+dy*(qxs(i)-xs(i))
 205        continue 
            y=y+dy*(ynew-y)
c
c  If full step can be made proceede to checking dual feasibility
c
            if (dy .gt. 1-1.0d-10) goto 600
c
c  if we have an infinite direction, go until the boundary is hit.
c
          else  
            mins0=inf
            imins0=0
            do 210 i=1, ns
              val=dir*qxs(i)
              if ( val .lt. -1.0d-10 .and. 
     .             xs(i)/(-val)<mins0 ) then
                mins0  = xs(i)/(-val)
                imins0=i
              endif
 210        continue      
            minsc=inf
            iminsc=0
            do 215 i=1, ns
              val=dir*qxs(i)
              if ( val  .gt. 1.0d-10 .and.  
     .             (c-xs(i))/val < minsc ) then
                 minsc  =(c-xs(i))/val
                 iminsc=i
              endif
 215        continue 
            dy=min(minsc, mins0)
            do 220 i=1,ns
              xs(i)=xs(i)+dy*dir*qxs(i)
 220        continue 
          endif
c
c  check which variable hit a bound
c
          if ( minsc .le. mins0  ) then
c
c  If this variable has just joined the active set,from the same bound value it is
c  trying to hit that means we are looping. This may happed due to numerical error and
c  typically occurs when near optimimum. Hence print a warning and assume that all constraints
c  in Ic and I0 are satisfied.
c
            if (is(iminsc).eq.ienter .and. laststep.eq.2) then
              if (iprint.ge.0) write(6,*) 
     .            'Looping occured: assuming near convergence'
              goto 1000
c
c  same as above but only the variable joined Is from Icdisc or I0disc, hence assume
c  complete optimality
c
            else if (is(iminsc).eq.ienter .and. laststep.eq.4) then
              if (iprint.ge.0) write(6,*) 
     .          'Looping occured: assuming near convergence'
              goto 2000
            endif
c 
c  support vector hits the upper bound the adjust Ic, ac and other 
c  arrays and values accordingly
c
            ic(nc+1)=is(iminsc)
            icind(nc+1)=0
            nc=nc+1
            ac=ac+a(ic(nc))
            do 228 i= 1, ns
              if ( perm(i).eq.iminsc ) then
                j=i
              elseif ( perm(i) .gt. iminsc ) then
               perm(i)=perm(i)-1
              endif
 228        continue 
c
c  remove apropriate row from the Cholesky factor
c 
            call rmvar(g, ldg, ns, j, nrnk)
c
c  rmvar is not working reliably if nrnk<ns, so demand refactorrization
c  of the last row (since if we are here nrnk>=ns-1)
c
            ibeg=nrnk
            if (nrnk .lt. ns-1 ) incactset=.true.
            do 229 i= j, ns-1
              perm(i)=perm(i+1)
 229        continue  
c
c  adjust is and xs removing the variable
c
            do 225 i=iminsc, ns-1
              is(i)=is(i+1)
              xs(i)=xs(i+1)
 225        continue
            ns=ns-1 
c
c Update Qc and Qs accordingly.
c
            call updtqc(1, qc, ic(nc), points, ipoints, lpnt, 
     .             ipntr,is, ic, i0, ns, nc, n0, i0disc, n0disc, 
     .              icdisc, ncdisc, a, c, n, maxn, k, shftk, dgrk, 
     .             qs(1,iqs(iminsc)), fullmem)
            call updtqs( iqs,  iminsc, ns, maxns)
            istep = 3
          elseif ( mins0 .le. minsc ) then
c
c  Same situation with looping as described above fore the case when minsc < mins0.
c
            if (is(imins0).eq.ienter .and. laststep.eq.1) then
              if (iprint.ge.0) write(6,*) 
     .          'Looping occured: assuming near convergence'
              goto 1000
            else if (is(imins0).eq.ienter .and. laststep.eq.3) then
              if (iprint.ge.0) write(6,*) 
     .          'Looping occured: assuming near convergence'
              goto 2000
            endif          
c
c  variable hits its lower bound
c
            i0(n0+1)=is(imins0)
            i0ind(n0+1)=0
            n0=n0+1
            do 236 i= 1, ns
              if ( perm(i).eq.imins0 ) then
                j=i
              elseif ( perm(i) .gt. imins0 ) then
                perm(i)=perm(i)-1
              endif
 236        continue
c
c remove appropriate row of Cholesky
c  
            call rmvar(g, ldg, ns, j, nrnk)
c
c  rmvar is not working reliably is nrnk<ns, so demand refactorrization
c  of the last row (since if we are here nrnk>=ns-1)
c
            ibeg=nrnk
            incactset=.true.
c
c adjust other related arrays and variables
c
            do 235 i= j, ns-1
              perm(i)=perm(i+1)
 235        continue  
            do 230 i=imins0, ns-1
              is(i)=is(i+1)
              xs(i)=xs(i+1)
 230        continue
            ns=ns-1
c
c  adjust the pointers in iqs to indicate the removal of the column from qs
c
            call updtqs( iqs, imins0, ns,  maxns)
            istep = 4
          else
            if (iprint.ge.0) write(6,*) 
     .         'No result in minimum ratio test'
            goto 2000
          endif 
          laststep=0
          goto 500

c
c  there are more than nrnk support vectors, solution is not unique
c  so we call the IPM qp routine to solve the reduced problem.
c  if the rank is half or less of the total problem size then we use
c  the product form CF technique within the IPM otherwise treat the 
c problem as a general full-rank dense problem.
c 

c
c if the step size is 1 then we moved all the way to minimum and we
c need to release one of the  variables from its bound
c
c check for the constraints that are violated (if a variable is on the 
c upper bound then corresponding xi has to be positive, otherwise s has
c to be positive. If this does not hold, the "violating" variable gets
c released from the bound and added to the active set Is.
 600      continue
          iterbig=iterbig+1
          minc=0.0d0 
          iminc=0
          min0=0.0d0 
          imin0=0 
          do 325 i=1,nc
            qxc(i)=0.0d0
 325      continue  
          do 335 j=1, ns
            do 330 i=1,nc
              qxc(i)=qxc(i)+qs(ic(i),iqs(j))*xs(j)
 330        continue 
 335      continue 
          do 340 i=1,nc
            qxc(i)=-qxc(i)-qc(ic(i))+a(ic(i))*y+1.0d0
            if ( qxc(i) .gt. 0 ) then 
              icind(i)=icind(i)+1
            else
              icind(i)=0
              if ( qxc(i) .lt. minc-1.0d-10 ) then
                iminc=i
                minc=qxc(i)
              endif
            endif       
 340      continue  
          do 345 i=1,n0
            qx0(i)=0.0d0
 345      continue  
          do 355 j=1, ns
            do 310 i=1,n0
              qx0(i)=qx0(i)+qs(i0(i),iqs(j))*xs(j)
 310        continue 
 355      continue         
          do 350 i=1,n0
            qx0(i)=qx0(i)+qc(i0(i))-a(i0(i))*y-1.0d0
            if ( qx0(i) .gt. 0 ) then 
              i0ind(i)=i0ind(i)+1
            else
              i0ind(i)=0
              if ( qx0(i) .lt. (min0-1.0d-10) ) then
                imin0=i
                min0=qx0(i)
              endif
            endif
 350      continue

c
c  minc is the maximum slack xi, min0 is the maxmum slack s. if either of them
c  is negative then we include the appropriate variable into the active set.
c
          if (min(min0, minc) .gt. -tol ) goto 1000
          if ( min0 .le. minc ) then
            is(ns+1)=i0(imin0)
            ns=ns+1
            ienter=is(ns)
            xs(ns)=0.0d0
            do 360 i=imin0,  n0-1
              i0(i)=i0(i+1)
              i0ind(i)=i0ind(i+1)
 360        continue
            n0=n0-1
            istep = 1
c          
c add a column to qs that corresponds to the new active variable.
c
            if (fullmem .eq. 2 ) then 
              call addcolqs(points,  ipoints, lpnt, ipntr, a, qs, 
     .                      iqs(ns), is,  ns, n,  maxn, maxns, 
     .                      k, shftk, dgrk, wrk, .false.) 
            else
              call addcolqsmin(points, ipoints, lpnt, ipntr, a, qs, 
     .                      iqs(ns), is, ic, i0,
     .                      ns,  nc, n0, 
     .                      maxn, maxns, k, shftk, dgrk, wrk, .false.) 
            endif
             ibeg=nrnk+1
             perm(ns)=ns
             incactset=.true.
             laststep=1
          elseif ( minc .le. min0 ) then
            iterc=iterc+1
c
c  violated point joins support vector set
c
            is(ns+1)=ic(iminc)
            ns=ns+1
            ienter=is(ns)
            ac=ac-a(ic(iminc))
            xs(ns)=c
            do 240 i=iminc, nc-1
              ic(i)=ic(i+1)
              icind(i)=icind(i+1)
 240        continue
            nc=nc-1
c
c  Subtract from qc the column of Q that corresponds to the released varible.
c  remeber that column in wrk array so that it can be used when added to qs.
c
 
              call updtqc(-1, qc, is(ns), points, ipoints, lpnt,  ipntr, 
     .                     is, ic, i0, ns, nc, n0, i0disc, n0disc, 
     .                     icdisc, ncdisc, a, c, n, maxn, k, shftk, 
     .                     dgrk, wrk, fullmem )
c 
c Update qs using information computed in updtqc subroutine.
c

            if (fullmem .eq. 2) then 
              call addcolqs(points, ipoints, lpnt, ipntr, a, qs,  
     .                      iqs(ns), is, ns, n,  maxn, maxns, 
     .                      k, shftk, dgrk, wrk, .true.) 
            else
              call addcolqsmin(points, ipoints, lpnt, ipntr, a, qs, 
     .                      iqs(ns), is, ic, i0,
     .                      ns,  nc, n0, 
     .                      maxn, maxns, k, shftk, dgrk,  wrk, .true.) 
            endif
            ibeg=nrnk+1
            perm(ns)=ns
            incactset=.true.
            laststep=2
          else
            if (iprint.ge.0) write(6,*) 
     .        'No result in minimum ratio test'
            goto 2000
          endif  
          goto 500
c
c  Before exiting check if any of the "discarded" points are actually violated now
c  This step is essentially identical to the step above in checking for violated constraints.
c  Only now the indices that are considered are those in Icdisc and I0disc.
 1000     minc=0.0d0 
          iminc=0
          if (fullmem .lt. 2) then
            do 1120 j=1,ns
              iq=iqs(j)
              do 1100 i=1, n0disc
                qs(i0disc(i), iq)=gkernlsp(points,ipoints, lpnt, ipntr,
     .               a,  is(j), i0disc(i), maxn, k,  shftk, dgrk  )
 1100         continue
              do 1110 i=1, ncdisc
                qs(icdisc(i), iq)=gkernlsp(points,ipoints, lpnt, ipntr,
     .              a, is(j), icdisc(i), maxn, k,  shftk, dgrk  )
 1110         continue
 1120       continue 
            fullmem=2
          endif
c
c  If using sifting, collect the indices with smallest values of the slack and surplus (violated ones
c  included).
c
          if ( usesift ) then 
            do 320 i=1, maxsift0
              minslk(i)=1.0d20
              iminslk(i)=0
 320        continue  
            do 321 i=1, maxsiftc
              minsur(i)=1.0d20
              iminsur(i)=0
 321        continue  
            do 1210 i=1,nc
              val=qxc(i)
              if ( val .lt. minsur(maxsiftc) ) then
                j=maxsiftc
                do while ( val .lt. minsur(j) .and. j .gt. 0)
                  j = j - 1
                end do
                do 1220 jj=maxsiftc-1, j+1, -1
                  minsur(jj+1)=minsur(jj)
                  iminsur(jj+1)=iminsur(jj)
 1220           continue
                minsur(j+1)=val
                iminsur(j+1)=i
              endif   
 1210       continue
            do 1240 i=1,n0
              val=qx0(i)
              if ( val .lt. minslk(maxsift0) ) then
                j=maxsift0
                do while ( val .lt. minslk(j) .and. j .gt. 0)
                  j = j - 1
                end do
                do 1230 jj=maxsift0-1, j+1, -1
                  minslk(jj+1)=minslk(jj)
                  iminslk(jj+1)=iminslk(jj)
 1230           continue
                minslk(j+1)=val
                iminslk(j+1)=i
              endif
 1240       continue
          endif

          do 1325 i=1,ncdisc
            qxc(i)=0.0d0
 1325     continue  
          do 1335 j=1, ns
            do 1330 i=1,ncdisc
              qxc(i)=qxc(i)+qs(icdisc(i),iqs(j))*xs(j)
 1330       continue 
 1335     continue 
          do 1340 i=1,ncdisc
            qxc(i)=-qxc(i)-qc(icdisc(i))+a(icdisc(i))*y+1.0d0
            if ( qxc(i) .lt. minc ) then
              iminc=i
              minc=qxc(i)
            endif
 1340     continue  
          min0=0.0d0 
          imin0=0 
          do 1345 i=1,n0disc
            qx0(i)=0.0d0
 1345     continue  
          do 1355 j=1, ns
            do 1310 i=1,n0disc
              qx0(i)=qx0(i)+qs(i0disc(i),iqs(j))*xs(j)
 1310        continue 
 1355      continue           
          do 1350 i=1,n0disc
            tmp=0.0d0
            qx0(i)=qx0(i)+qc(i0disc(i))-a(i0disc(i))*y-1.0d0
            if ( qx0(i) .lt. min0 ) then
              imin0=i
              min0=qx0(i)
            endif
 1350     continue 
          if ( usesift ) then 
            do 1360 i=1,n0disc
              val=qx0(i)
              if ( val .lt. minslk(maxsift0) ) then
                j=maxsift0
                do while ( val .lt. minslk(j) .and. j .gt. 0)
                  j = j - 1
                end do
                do 1365 jj=maxsift0-1, j+1, -1
                  minslk(jj+1)=minslk(jj)
                  iminslk(jj+1)=iminslk(jj)
 1365           continue
                minslk(j+1)=val
                iminslk(j+1)=-i
              endif   
 1360       continue
            do 1370 i=1,ncdisc
              val=qxc(i)
              if ( val .lt. minsur(maxsiftc) ) then
                j=maxsiftc
                do while ( val .lt. minsur(j) .and. j .gt. 0)
                  j = j - 1
                end do
                do 1375 jj=maxsiftc-1, j+1, -1
                  minsur(jj+1)=minsur(jj)
                  iminsur(jj+1)=iminsur(jj)
 1375           continue
                minsur(j+1)=val
                iminsur(j+1)=-i
              endif
 1370       continue
c
c   Collect information about indices to distribute them into different sets ns, n0, nc, n0disc, ncdisc
c
            do 1381 i=1,ns
              iwrk(icuriw+is(i))=0
 1381       continue 
            do 1382 i=1,n0disc
              iwrk(icuriw+i0disc(i))=1
 1382       continue 
            do 1383 i=1,n0
              iwrk(icuriw+i0(i))=1
 1383      continue 
            do 1384 i=1,ncdisc
              iwrk(icuriw+icdisc(i))=2
 1384       continue 
            do 1385 i=1,nc
              iwrk(icuriw+ic(i))=2
 1385       continue 
            do 1386 i=1,maxsiftc
              if ( iminsur(i).gt. 0 ) then
                  iwrk(icuriw+ic(iminsur(i)))=4
              elseif ( iminsur(i).lt. 0 ) then
                  iwrk(icuriw+icdisc(-iminsur(i)))=4
              endif
 1386       continue
            do 1387 i=1,maxsift0
              if ( iminslk(i).gt. 0 ) then
                  iwrk(icuriw+i0(iminslk(i)))=3
              else if ( iminslk(i).lt. 0 ) then
                  iwrk(icuriw+i0disc(-iminslk(i)))=3
              endif
 1387       continue 
          endif
c
c  if the minimum slack and surplus are not violated, go to exit.
c  otherwise add appropriate variable to the Is set.
c
          if (min(min0, minc) .gt. -tol ) goto 2000
          if ( min0 .le. minc ) then
            is(ns+1)=i0disc(imin0)
            if (usesift)  iwrk(icuriw+i0disc(imin0))=0
            ns=ns+1
            ienter=is(ns)
            xs(ns)=0.0d0
            do 1410 i=imin0,  n0disc-1
              i0disc(i)=i0disc(i+1)
 1410       continue
            n0disc=n0disc-1
            if (fullmem .eq. 2 ) then 
              call addcolqs(points,  ipoints, lpnt, ipntr, a, qs, 
     .                      iqs(ns), is,  ns,  n, maxn, maxns, 
     .                      k, shftk, dgrk, wrk, .false.) 
            else
              call addcolqsmin(points, ipoints, lpnt, ipntr, a, qs, 
     .                      iqs(ns), is, ic, i0,
     .                      ns,  nc, n0, 
     .                      maxn, maxns, k, shftk, dgrk,  wrk, .false.) 
            endif
            ibeg=nrnk+1
            perm(ns)=ns
            incactset=.true.
            laststep=3
          elseif ( minc .le. min0 ) then
            iterc=iterc+1
c
c  violated point joins support vector set
c
            is(ns+1)=icdisc(iminc)
            if (usesift)  iwrk(icuriw+icdisc(iminc))=0
            ns=ns+1
            ienter=is(ns)
            ac=ac-a(icdisc(iminc))
            xs(ns)=c
            do 1440 i=iminc, ncdisc-1
              icdisc(i)=icdisc(i+1)
 1440       continue
            ncdisc=ncdisc-1 
            call updtqc(-1, qc, is(ns), points, ipoints, lpnt,  
     .                  ipntr, is, ic, i0, ns, nc, n0, i0disc,
     .                  n0disc, icdisc, ncdisc, 
     .                  a, c, n, maxn, k, shftk, dgrk, wrk, fullmem )
 1422       continue  
            if (fullmem .eq. 2) then 
              call addcolqs(points, ipoints, lpnt, ipntr, a, qs,  
     .                      iqs(ns), is, ns, n, maxn, maxns, 
     .                      k, shftk, dgrk, wrk, .true.) 
            else
              call addcolqsmin(points, ipoints, lpnt, ipntr, a, qs, 
     .                      iqs(ns), is, ic, i0,
     .                      ns,  nc, n0, 
     .                      maxn, maxns, k, shftk, dgrk, wrk, .true.) 
            endif
            ibeg=nrnk+1
            perm(ns)=ns
            incactset=.true.
            laststep=4
          endif  
          if ( usesift ) then   
            n0=0
            nc=0
            ncdisc=0
            n0disc=0
            do 1500 i=1,n
              if (iwrk(icuriw+i).eq. 1) then
                n0disc=n0disc+1
                i0disc(n0disc)=i
              elseif  (iwrk(icuriw+i).eq. 2) then
                ncdisc=ncdisc+1
                icdisc(ncdisc)=i
              elseif  (iwrk(icuriw+i).eq. 3) then
                n0=n0+1
                i0(n0)=i
              elseif  (iwrk(icuriw+i).eq. 4) then
                nc=nc+1
                ic(nc)=i
              endif
 1500       continue
          endif  

 500  continue 
c
c If using sifting, recompute the sets of indices. If incremental mode is used, these sets will
c be reused at the next step, when more points are available.
c
 2000 continue
         if ( usesift .and. ns. le. maxns ) then   
          n0=0
          nc=0
          ncdisc=0
          n0disc=0
          do 1510 i=1,n
            if (iwrk(icuriw+i).eq. 1) then
              n0disc=n0disc+1
              i0disc(n0disc)=i
            elseif  (iwrk(icuriw+i).eq. 2) then
              ncdisc=ncdisc+1
              icdisc(ncdisc)=i
            elseif  (iwrk(icuriw+i).eq. 3) then
              n0=n0+1
              i0(n0)=i
            elseif  (iwrk(icuriw+i).eq. 4) then
              nc=nc+1
              ic(nc)=i
            endif
 1510     continue
        endif 
  
c
c  record the solution in the vector 'x'.
c
        do 520 i=1, ns
          x(is(i))=xs(i)      
 520    continue
        do 530 i=1, nc
          x(ic(i))=c
 530    continue
        do 540 i=1, n0
          x(i0(i))=0.0d0
 540    continue 
        do 550 i=1, ncdisc
          x(icdisc(i))=c
 550    continue
        do 560 i=1, n0disc
          x(i0disc(i))=0.0d0
 560    continue 
c        iter=iterbig      
c      timediff=mclock()-totalt
c      totalt=totalt+timediff      
c      write(6,*) 'cpu time=', totalt/100
c      write(6,*) 'iterations=', iter
c      write(6,*) 'ns=', ns
c      write(6,*) 'y=', y
c      write(44,*) 'cpu time=', totalt/100
c      write(44,*) 'iterations=', iter
c      write(44,*) 'ns=', ns
c      write(44,*) 'y=', y 
 3000 return
      end



      subroutine updtqs(iqs, imins, ns, maxns )
      integer           iqs(maxns),  imins,  ns, maxns, i, j
      i=iqs(imins)
      do 10 j=imins, ns
        iqs(j)=iqs(j+1)
 10   continue
      iqs(ns+1)=i
      return
      end  

      subroutine addcolqs(points, ipoints, lpnt, ipntr, a, qs, iq, is, 
     .                  ns,  n, maxn, maxns, 
     .                  k, shftk, dgrk, wrk, ready  )
      double precision  points(lpnt), a(maxn), qs(maxn, maxns), shftk,
     .                  wrk(maxn)
      integer           is(ns),  iq, maxns, maxn, n, imins, ipntr(maxn),
     .                  i, j, dgrk, ns,  k, ipoints(lpnt), lpnt 
      double precision  gkernlsp
      external          gkernlsp
      logical           ready
      if ( ready ) then
        do 5 i=1, n
          qs(i, iq)=wrk(i)
 5      continue
      else  
        do 10 i=1, n
          qs(i, iq)=gkernlsp(points,  ipoints, lpnt, ipntr, a, is(ns),
     .                 i, maxn, k,  shftk, dgrk  )
 10     continue
      endif
      return
      end



      subroutine addcolqsmin(points, ipoints, lpnt, ipntr, a, qs, iq, 
     .                  is,  ic, i0, ns, nc, n0,  
     .                  maxn, maxns, k, shftk, dgrk, wrk, ready  )
      double precision  points(lpnt), a(maxn), qs(maxn, maxns), shftk,
     .                  wrk(maxn)
      integer           is(ns), ic(nc), i0(n0), iq, maxns, maxn, imins, 
     .                  i, j, dgrk, ns, n0, nc, k, ipoints(lpnt), lpnt, 
     .                  ipntr(maxn)
      double precision  gkernlsp
      external          gkernlsp
      logical           ready
      if ( ready ) then
        do 11 i=1, ns
          qs(is(i), iq)=wrk(is(i))
 11     continue
        do 22 i=1, nc
          qs(ic(i), iq)=wrk(ic(i))
 22     continue
        do 33 i=1, n0
          qs(i0(i), iq)=wrk(i0(i))
 33     continue
      else
        do 10 i=1, ns
          qs(is(i), iq)=gkernlsp(points, ipoints, lpnt, ipntr, a, 
     .              is(ns), is(i), maxn, k,  shftk, dgrk  )
 10     continue
        do 20 i=1, nc
          qs(ic(i), iq)=gkernlsp(points, ipoints, lpnt, ipntr, a, 
     .              is(ns), ic(i), maxn, k,  shftk, dgrk  )
 20     continue
        do 30 i=1, n0
          qs(i0(i), iq)=gkernlsp(points, ipoints, lpnt, ipntr,  a, 
     .               is(ns), i0(i), maxn, k,  shftk, dgrk  )
 30     continue
      endif
      return
      end

      subroutine addrow(points,   ipoints, lpnt, ipntr, a, qs, iq, i,
     .                   is, ns, maxn, maxns, k, shftk, dgrk  )
      double precision  points(lpnt), a(maxn), qs(maxn, maxns), shftk
      integer           is(ns),  iq(maxns), maxns, maxn, imins, 
     .                  i, j, dgrk, ns, k, ipoints(lpnt), lpnt, 
     .                  ipntr(maxn)
      double precision  gkernlsp
      external          gkernlsp
      do 10 j=1, ns
        qs(i, iq(j))=gkernlsp(points,  ipoints, lpnt, ipntr, a, i, 
     .              is(j), maxn, k,  shftk, dgrk  )
 10   continue
      return
      end



      subroutine updtqc(mul, qc, iq,  points, ipoints, lpnt, 
     .                  ipntr,  is, ic, i0, ns, nc, n0, i0disc,
     .                  n0disc, icdisc, ncdisc, a, c, n, maxn,
     .                   k, shftk, dgrk, wrk,  fullmem  )
      double precision  points(lpnt), a(maxn), qc(maxn), shftk, c, 
     .                  wrk(maxn)
      integer           iq, n, maxn, imins, fullmem, ii, n0disc, ncdisc, 
     .                  i, j, dgrk, ns, n0, nc, k, mul, ipoints(lpnt),
     .                  lpnt, ipntr(maxn), is(ns), ic(nc), i0(n0),
     .                  i0disc(n0disc), icdisc(ncdisc)
      double precision  gkernlsp
      external          gkernlsp
      if ( mul .eq. 1 ) then
        if (fullmem .eq. 2) then 
          do 10 i=1, n
            qc(i)=qc(i)+c*wrk(i)
 10       continue  
        else
          do 11 i=1, ns
            ii=is(i)
            qc(ii)=qc(ii)+c*wrk(ii)
 11       continue
          do 12 i=1, n0
            ii=i0(i)
            qc(ii)=qc(ii)+c*wrk(ii)
 12       continue
          do 13 i=1, nc
            ii=ic(i)
            qc(ii)=qc(ii)+c*wrk(ii)
 13       continue
          do 21 i=1, ncdisc
            ii=icdisc(i)
            qc(ii)=qc(ii)+c*gkernlsp(points, ipoints, 
     .                lpnt, ipntr, a, iq, ii, maxn, k,  
     .                shftk, dgrk)
 21       continue
          do 22 i=1, n0disc
            ii=i0disc(i)
            qc(ii)=qc(ii)+c*gkernlsp(points, ipoints, 
     .                lpnt, ipntr, a, iq, ii, maxn, k, 
     .                shftk, dgrk)
 22       continue
        endif
      else
        do 20 i=1, n
          wrk(i)=gkernlsp(points, ipoints, lpnt, ipntr,
     .                 a, iq, i, maxn, k,  shftk, dgrk  )
          qc(i)=qc(i)-c*wrk(i)
 20     continue
      endif
      return
      end

