cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  SVM-QP, written by Katya Scheinberg, IBM Research, 2005.
c  to contact the author email at katyas'at'us'dot'ibm'dot'com
c
c Copyright (C) 2005 International Business Machines.
c All Rights Reserved.
c This code is published under the Common Public License.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine cholpiv( qs, iqs, is, g, ldg, perm,  ibeg, n, nrnk,  
     *                    maxn, maxns, tol)
     
      double precision qs(maxn, maxns), g(ldg, n), 
     *                 tol, zero, temp, maxg, trace, traceq
      integer          k, n, nrnk, imaxg, i, j, jj, perm(n), ibeg,  
     *                 itemp, ldg, iqs(n), is(n), maxns, maxn
      intrinsic        sqrt
      zero=0.0d0
c      do 10 i=1, n
c        perm(i)=i
c 10   continue  
      do 1 j=1, ibeg-1
        do 2 i=ibeg, n
          g(i, j) = qs(is(perm(i)),iqs(perm(j)))
 2      continue  
 1    continue  
      do 5 i=ibeg, n
        do 6 j=1, ibeg-1
          do 7 jj=1, j-1
            g(i, j)=g(i, j)-g(i, jj)*g(j,jj)
 7        continue
          g(i,j)=g(i,j)/g(j,j)
 6      continue
 5    continue  
      do 100 i = ibeg, n
        do 15 j = 1,i-1
          g(j, i) = zero
 15     continue
        trace=zero 
        traceq=zero 
        do 20 j = i, n
          g(j, i)=qs(is(perm(j)), iqs(perm(j)))
          traceq=traceq+g(j, i)
          do 30 jj=1, i-1
            g(j, i)=g(j, i) -g(j, jj)**2
 30       continue
          trace=trace+g(j, i)
 20     continue  
        if ( trace .le. tol*(1.0d0+traceq) .or. 
     .     trace .le. 1.0d-8  ) then
           nrnk=i-1
           goto 200
        else
          maxg=0.0d0
          imaxg=0
          do 40 j=i, n
            if (g(j, i) .gt. maxg) then
              maxg=g(j, i)
              imaxg=j
            endif
 40       continue
          itemp=perm(i)
          perm(i)=perm(imaxg)
          perm(imaxg)=itemp  
          do 50 j=1, i-1
            temp=g(i, j)
            g(i, j)=g(imaxg, j)
            g(imaxg, j)=temp
 50       continue
          g(i,i)=sqrt(maxg)
          do 60 j=i+1, n
            g(j, i) = qs(is(perm(j)),iqs(perm(i)))
            do 70 jj=1, i-1
              g(j, i)=g(j, i)-g(j, jj)*g(i,jj)
 70         continue
            g(j,i)=g(j,i)/g(i,i)
 60       continue
        endif
 100  continue
      nrnk = n
 200  continue
c      do 300 i=1, n
c        do 310 j=1, n
c          temp=0.0d0
c          do 320 jj=1, nrnk
c            temp=temp+g(i,jj)*g(j,jj)
c 320      continue
c          if (abs( temp -qs(is(perm(i)), iqs(perm(j)))) .gt. 1.0d-10) 
c     .        then 
c            write(6,*) 'error in g!!', i, j, temp, 
c     .      qs(is(perm(i)), iqs(perm(j)))
c          endif
c 310    continue
c 300  continue  
      return
      end

      subroutine frwslvpiv(g, ldg, x, perm, n, nrnk)
      double precision    g(ldg,n), x(n)
      integer             perm(n), n, i, j, ip, jp, nrnk, ldg
      do 10 i = 1, n
        ip=perm(i)
        if ( i .gt. nrnk ) then
c          x(ip)=0.0d0
        else
          x(ip)=x(ip)/g(i,i)
          do 20 j = i+1, n
            jp=perm(j)
            x(jp)=x(jp)-x(ip)*g(j,i)
 20       continue
        endif
 10   continue
      return
      end  


      subroutine bkwslvpiv(g, ldg, x, perm, n, nrnk)
      double precision    g(ldg,n), x(n)
      integer             perm(n), n, i, j, ip, jp, nrnk, ldg
      do 10 i = n, 1, -1
        ip=perm(i)
        if ( i .gt. nrnk ) then
c          x(ip)=0.0d0
        else
          x(ip)=x(ip)/g(i,i)
          do 20 j = i-1, 1, -1
            jp=perm(j)
            x(jp)=x(jp)-x(ip)*g(i,j)
 20       continue
        endif
 10   continue
      return
      end  


      SUBROUTINE RMVAR( L, LDL, N, IRMV, NRNK)
C
C  ROUTINE PARAMETERS
C
      DOUBLE PRECISION  L(LDL, N)
      INTEGER           LDL, N, K, IRMV, NRNK
C
C  LOCAL VARIABLES
C
      DOUBLE PRECISION  T, S, C
      INTEGER            I, J, JK, IK, IK1  

C
C  REMOVE THE "IRMV"-TH ROW FROM CHOLESKY
C  
        DO 05 J=1, NRNK
          DO 06 I=IRMV, N-1
            L(I , J) = L(I  +1, J)
 06       CONTINUE
 05     CONTINUE
C
C DO GIVENS ROTATIONS TO REDUCE THE MATRIX TO
C THE LOWER TRIANGULAR FORM
C   
        DO 10 I=IRMV, NRNK-1
          T  = SQRT(L(I, I)*L(I, I)+L(I, I+1)*L(I, I+1))
          C  = L(I, I)/T
          S  =-L(I, I+1)/T
          DO 20 J=I, N-1
            T  = L( J, I )
            L(J, I)=C*T-S*L(J, I+1)
            L(J, I+1)=S*T+C*L(J, I+1)
 20       CONTINUE
 10     CONTINUE
      IF (  IRMV .LE. NRNK ) NRNK=NRNK-1
      RETURN
      END


  
      SUBROUTINE ADVAR( L, LDL, ns, nrnk, perm, qs, is,  erro, tol, 
     .                  maxn, iwrk )
C
C  ROUTINE PARAMETERS
C
      DOUBLE PRECISION  L(LDL, ns), erro, tol, qs(maxn)
      INTEGER           LDL, ns, perm(ns), iwrk(ns), iqs, is(ns), nrnk,
     .                  maxn, i
C
C  LOCAL VARIABLES
C
      DOUBLE PRECISION  PROD
      INTRINSIC         SQRT
      DOUBLE PRECISION  DDOT
      EXTERNAL          DDOT
C
C  IF L IS NOT EMPTY CREATE THE APPROPRIATE NEW ROW OF L
C  IF L IS EMPTY THEN THE NEW L IS JUST A SCALAR (Z'*Z)^(1/2)
C
      if ( nrnk .lt. ns-1 ) then
        erro=1
        return
      endif
      IF ( ns .GT. 1) THEN
        do 10 i=1, ns-1
          l(i, ns)=qs(is(perm(i)))
          iwrk(i)=i
 10     continue
        l(ns,ns)=qs(is(ns))
        call  frwslvpiv(L, ldl, L(1, ns), iwrk, ns-1, ns-1)
        PROD = DDOT( ns-1, L(1, ns), 1, L(1, ns), 1)
        if ( (l(ns, ns)-prod)/(1.0d0+prod) .lt. tol ) then
          erro=1
        else
          L(ns, ns)=SQRT(L(ns, ns)- PROD)
          perm(ns)=ns
          call DCOPY(ns-1, L(1, ns), 1, L(ns, 1), ldl)
          erro=0
        endif
        do 20 i=1, ns-1
          l(i, ns)=0.0d0
 20     continue
      ELSE
         erro=1
      ENDIF
      RETURN
      END

