cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  SVM-QP, written by Katya Scheinberg, IBM Research, 2005.
c  to contact the author email at katyas'at'us'dot'ibm'dot'com
c
c Copyright (C) 2005 International Business Machines.
c All Rights Reserved.
c This code is published under the Common Public License.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double precision function gkernl(points, a, i, j, n, k, shft, dgr)
      double precision points(n, k), a(n), kernl, shft
      intrinsic        exp
      integer          i, j, n, k, l, dgr
      double precision ddot
      external ddot
      kernl=0.0d0
      if ( dgr .ge. 0 ) then 
c        do 10 l=1, k
c          kernl=kernl+points(i, l)*points(j,l)
c 10     continue
         kernl=ddot(k, points(i, 1), n, points(j, 1), n)
        gkernl=((kernl+shft)**dgr*a(i)*a(j))
      else
        do 20 l=1, k
          kernl=kernl+(points(i, l)-points(j,l))**2
 20     continue  
        gkernl=exp(-kernl/shft)*a(i)*a(j)  
      endif   
      return
      end  


      double precision function gkernlsp(points, ipoints, lpnt, ipntr, 
     .                          a, i, j, n, k, shft, dgr)
      double precision points(lpnt), a(n), kernl, shft
      intrinsic        exp
      integer          i, j, n, k, l, ll,  dgr, ipoints(*), lpnt, kk, 
     .                 ipntr(*), itemp, jtemp
      logical          sparse
      integer          ncalls
      double precision timek, tt, temp
      common /sprs/    sparse, ncalls, timek
      double precision ddot, dnrm2
      external ddot, dnrm2
      ncalls=ncalls+1
      if ( sparse ) then
        kernl=0.0d0
        ll=ipntr(j)
        if ( dgr .ge. 0 ) then 
          do 10 l=ipntr(i), ipntr(i+1)-1
 100        if ( ll .ge. ipntr(j+1) .or. l .ge. ipntr(i+1)) goto 300
            if ( ipoints(l) .eq. ipoints(ll) ) then
              kernl=kernl+points(l)*points(ll)
            else if ( ipoints(l) .gt. ipoints(ll) ) then
              ll=ll+1
              goto 100
            endif
 10       continue  
 300      gkernlsp=((kernl+shft)**dgr*a(i)*a(j))
        else
          do 20 l=ipntr(i), ipntr(i+1)-1
 200        if ( ipoints(l) .lt. ipoints(ll) .or. ll .ge. ipntr(j+1)) 
     .        then
              kernl=kernl+(points(l))**2
            else if ( ipoints(l) .eq. ipoints(ll) ) then
              kernl=kernl+(points(l)-points(ll))**2
              ll=ll+1
            else
              kernl=kernl+(points(ll))**2
              ll=ll+1
              goto 200
            endif
 20       continue
          if ( ll .lt. ipntr(j+1) ) then
            do 30 l= ll, ipntr(j+1)-1
              kernl=kernl+(points(l))**2
 30         continue
          endif  
          gkernlsp=exp(-kernl/shft)*a(i)*a(j)
        endif
      else
        if ( dgr .eq. 1 ) then 
          kernl=ddot(k, points((i-1)*k+1), 1, points((j-1)*k+1), 1)
          gkernlsp=kernl*a(i)*a(j)
        else  if ( dgr .gt. 1 ) then 
          kernl=ddot(k, points((i-1)*k+1), 1, points((j-1)*k+1), 1)
          gkernlsp=((kernl+shft)**dgr*a(i)*a(j))
        else
          kernl=0.0d0
          itemp=(i-1)*k
          jtemp=(j-1)*k
          do 120 l=1, k
            temp=points(itemp+l)-points(jtemp+l)
            kernl=kernl+temp*temp
 120       continue
          gkernlsp=exp(-kernl/shft)*a(i)*a(j)  
        endif
      endif     
      continue
      return
      end  





