cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  SVM-QP, written by Katya Scheinberg, IBM Research, 2005.
c  to contact the author email at katyas'at'us'dot'ibm'dot'com
c
c Copyright (C) 2005 International Business Machines.
c All Rights Reserved.
c This code is published under the Common Public License.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      program qpmain
c
      integer          lwrk, liwrk, n,  k, i, r, nrnk, dgr, 
     *                 itest
c
c  memory allocation
c
      parameter       (lwrk=50000000, liwrk=30000000)
      double precision wrk(lwrk)
      integer          iwrk(liwrk)
      character*64     data1, data2
      CHARACTER*80 VALUE
c
c  memory pointers
c
      integer          ia,  ipoints, ix, is, ixi, id, ip, ibeta, 
     *                 ilambda, nrnka, icuriwo, icurwo,
     *                 idx, ids, idxi, ic, icurw, ir, m, j, iperm, 
     *                 ig, itrc, icuriw, maxsift0, maxsiftc, iospec,
     *                 maxit, maxns, maxn, ninit,  lpnt, iipoints, 
     *                 iipntr, lipnts, lipntr, ncalls, fullmem, iprint
      logical          usesift, sparse, cornrsln, presolve
      double precision timek,  currt, totalt
      common /sprs/    sparse, ncalls, timek
c
c  other local variables
c
      double precision y, tol, c, shft
      INTEGER          INSPEC
      PARAMETER      ( INSPEC = 46 ) 
c
c  dimensions of the problem: n - number of data points, k - dimension
c                             of the data set.
c
       value='incas.spc'
       OPEN( INSPEC , FILE = value, FORM = 'FORMATTED',
     +      STATUS = 'OLD', IOSTAT = IOSPEC )
       REWIND INSPEC

       READ(INSPEC,6000) itest, nrnka, dgr, shft, c, iprint, fullmem, 
     +                   ninit
       CLOSE ( INSPEC )
       write(6,*) itest, nrnka, dgr, shft, c, iprint, fullmem, 
     +                   ninit

       if ( itest .eq. 1) then
c random dense problem
         maxn=1000
         k=10
         sparse=.false.
        data1 = './random_dense'
       else if (itest .eq. 2) then
c random sparse problem
         maxn=1000
         k=100
         sparse=.true.
        data1 = './random_sparse_pntr'
        data2 = './random_sparse_data'
       else 
         write(6,*) 'ERROR!! Not a valid test number' 
         goto 2000
       endif

c
c  tolerance for optimality
c
      tol=1.0d-6
c
c  setting some values (do not alter this unless revising the code)
c
      n = maxn
      maxns=1500
c
c  set the memory pointers
c
      ia      = 1
      ipoints = ia + n
      ic      = ipoints + n*k
      ir      = ic + n
      ix      = ir + n
      icurw   = ix + n
      if (sparse) then
        lipnts=n*k
        lipntr=n+1
      else
        lipnts=1
        lipntr=1
      endif
      iipoints= 1
      iipntr  = iipoints + lipnts
      icuriw = iipntr + lipntr
c
c  get the data
c      
      call getinput(wrk(ia), wrk(ipoints), iwrk(iipoints), lpnt, 
     .              lipnts, iwrk(iipntr), lipntr, c, wrk(ir), maxn, 
     .              k, data1, data2)

      ncalls=0
      call svmqp(wrk(ix), y, wrk(ia), wrk(ipoints), iwrk(iipoints), 
     .           lpnt, lipnts, iwrk(iipntr), lipntr, c, wrk(ir), 
     .           maxn, maxns, k, nrnka, dgr, shft, iprint, fullmem, 
     .           ninit, presolve, tol, wrk(icurw), lwrk-icurw,  
     .           iwrk(icuriw), liwrk-icuriw)


 2000 continue
 6000 format( 3(I4,/), D8.4, /, D8.4, /,3(I4,/) ) 
      end



      subroutine getinput(a, points, ipoints, lpnt, lipnts,
     .                    ipntr, lipntr,  c, r, n, k, data1, data2 )
c
c     gets the data for the quadratic problem: 
c     the are two case: sparse and dense
c     in  the sparse case only the nonzero entries of
c     the points are stores in array points, array ipoints
c     indicates the indices of the nonzero entries. Array
c     inptr stores the indices in array ipoint where each
c     new point begins. This is a standard sparse data 
c     matrix structure. It is assumed that this data is
c     written in two files: one file contains the nonzero entries 
c     and their indices, written alternatively (one number per line)
c     The second array has for each point the index where that point
c     begins in the first file (ipntr) and the lalbel of that points.
c     These, again, are written alternatively, one number per line.
c
c     In the dense case, array points is just a n by k matrix
c     ipoints and ipntr are not used. There is only one data file,
c     where the entries of each point are written consequitively
c     and are followed by the label. One number per line.
c 
c     a  is the array of labels.
c
      integer n, k, i, j, lwrk, ix, iospec, lpnt, lipnts, lipntr,
     .        ipoints(lipnts), ipntr(lipntr), ncalls
      double precision a(n),  points(n*k), r(n), c
      character*64     data1, data2
      logical          sparse
      double precision timek
      common /sprs/    sparse, ncalls, timek
c
c  set the vector e. In the active set method this is not used,
c  the actual value of -1 is used,currently. But in interior point code,
c  the vector r is used as defined, here, hence it is possible to use another
c  r in case one solves a slightly different porblem
c 
      do 5 i=1, n
        r(i)=-1.0d0
 5    continue
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   the sparse case                                        c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      if ( sparse ) then
c
c  open the file of the file of pointers 
c

        OPEN( 45 , FILE = data1, FORM = 'FORMATTED',
     +        STATUS = 'OLD', IOSTAT = IOSPEC )
        REWIND 45
c
c  read the file of pointers and labels
c
        do 10 i=1, n
            READ ( 45, 3500 ) ipntr(i)
            READ ( 45, 3000 ) a(i)
 10     continue
        READ ( 45, 3500 ) ipntr(n+1)
        lpnt=ipntr(n+1)-1
c
c  read the file of ppints and their indices
c
        OPEN( 45 , FILE = data2, FORM = 'FORMATTED',
     +        STATUS = 'OLD', IOSTAT = IOSPEC )
        REWIND 45
        do 20 i=1, lpnt
            READ ( 45, 3000 ) points(i)
            READ ( 45, 3500 ) ipoints(i)
 20     continue
      else
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   the dense case                                        c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c
c  open the file of the data points

       OPEN( 45 , FILE = data1, FORM = 'FORMATTED',
     +       STATUS = 'OLD', IOSTAT = IOSPEC )
       REWIND 45
c
c  read the data points and the labels
c
        do 50 i=1, n
          do 60 j=1, k
            READ ( 45, 3000 ) points((i-1)*k+j)
 60       continue
          READ ( 45, 3000 ) a(i)
 50     continue 
        lpnt=n*k
      endif  
      return
 3000 format( D12.8 )
 3500 format( I8 )
      end


